# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class BasePathMapping(pulumi.CustomResource):
    """
    Connects a custom domain name registered via `aws_api_gateway_domain_name`
    with a deployed API so that its methods can be called via the
    custom domain name.
    """
    def __init__(__self__, __name__, __opts__=None, rest_api=None, base_path=None, domain_name=None, stage_name=None):
        """Create a BasePathMapping resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not rest_api:
            raise TypeError('Missing required property rest_api')
        elif not isinstance(rest_api, basestring):
            raise TypeError('Expected property rest_api to be a basestring')
        __self__.rest_api = rest_api
        """
        The id of the API to connect.
        """
        __props__['restApi'] = rest_api

        if base_path and not isinstance(base_path, basestring):
            raise TypeError('Expected property base_path to be a basestring')
        __self__.base_path = base_path
        """
        Path segment that must be prepended to the path when accessing the API via this mapping. If omitted, the API is exposed at the root of the given domain.
        """
        __props__['basePath'] = base_path

        if not domain_name:
            raise TypeError('Missing required property domain_name')
        elif not isinstance(domain_name, basestring):
            raise TypeError('Expected property domain_name to be a basestring')
        __self__.domain_name = domain_name
        """
        The already-registered domain name to connect the API to.
        """
        __props__['domainName'] = domain_name

        if stage_name and not isinstance(stage_name, basestring):
            raise TypeError('Expected property stage_name to be a basestring')
        __self__.stage_name = stage_name
        """
        The name of a specific deployment stage to expose at the given path. If omitted, callers may select any stage by including its name as a path element after the base path.
        """
        __props__['stageName'] = stage_name

        super(BasePathMapping, __self__).__init__(
            'aws:apigateway/basePathMapping:BasePathMapping',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'restApi' in outs:
            self.rest_api = outs['restApi']
        if 'basePath' in outs:
            self.base_path = outs['basePath']
        if 'domainName' in outs:
            self.domain_name = outs['domainName']
        if 'stageName' in outs:
            self.stage_name = outs['stageName']
