# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class IntegrationResponse(pulumi.CustomResource):
    """
    Provides an HTTP Method Integration Response for an API Gateway Resource.
    
    -> **Note:** Depends on having `aws_api_gateway_integration` inside your rest api. To ensure this
    you might need to add an explicit `depends_on` for clean runs.
    """
    def __init__(__self__, __name__, __opts__=None, content_handling=None, http_method=None, resource_id=None, response_parameters=None, response_parameters_in_json=None, response_templates=None, rest_api=None, selection_pattern=None, status_code=None):
        """Create a IntegrationResponse resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if content_handling and not isinstance(content_handling, basestring):
            raise TypeError('Expected property content_handling to be a basestring')
        __self__.content_handling = content_handling
        """
        Specifies how to handle request payload content type conversions. Supported values are `CONVERT_TO_BINARY` and `CONVERT_TO_TEXT`. If this property is not defined, the response payload will be passed through from the integration response to the method response without modification.
        """
        __props__['contentHandling'] = content_handling

        if not http_method:
            raise TypeError('Missing required property http_method')
        elif not isinstance(http_method, basestring):
            raise TypeError('Expected property http_method to be a basestring')
        __self__.http_method = http_method
        """
        The HTTP method (`GET`, `POST`, `PUT`, `DELETE`, `HEAD`, `OPTIONS`, `ANY`)
        """
        __props__['httpMethod'] = http_method

        if not resource_id:
            raise TypeError('Missing required property resource_id')
        elif not isinstance(resource_id, basestring):
            raise TypeError('Expected property resource_id to be a basestring')
        __self__.resource_id = resource_id
        """
        The API resource ID
        """
        __props__['resourceId'] = resource_id

        if response_parameters and not isinstance(response_parameters, dict):
            raise TypeError('Expected property response_parameters to be a dict')
        __self__.response_parameters = response_parameters
        """
        A map of response parameters that can be read from the backend response.
        For example: `response_parameters = { "method.response.header.X-Some-Header" = "integration.response.header.X-Some-Other-Header" }`,
        """
        __props__['responseParameters'] = response_parameters

        if response_parameters_in_json and not isinstance(response_parameters_in_json, basestring):
            raise TypeError('Expected property response_parameters_in_json to be a basestring')
        __self__.response_parameters_in_json = response_parameters_in_json
        """
        **Deprecated**, use `response_parameters` instead.
        """
        __props__['responseParametersInJson'] = response_parameters_in_json

        if response_templates and not isinstance(response_templates, dict):
            raise TypeError('Expected property response_templates to be a dict')
        __self__.response_templates = response_templates
        """
        A map specifying the templates used to transform the integration response body
        """
        __props__['responseTemplates'] = response_templates

        if not rest_api:
            raise TypeError('Missing required property rest_api')
        elif not isinstance(rest_api, basestring):
            raise TypeError('Expected property rest_api to be a basestring')
        __self__.rest_api = rest_api
        """
        The ID of the associated REST API
        """
        __props__['restApi'] = rest_api

        if selection_pattern and not isinstance(selection_pattern, basestring):
            raise TypeError('Expected property selection_pattern to be a basestring')
        __self__.selection_pattern = selection_pattern
        """
        Specifies the regular expression pattern used to choose
        an integration response based on the response from the backend. Setting this to `-` makes the integration the default one.
        If the backend is an `AWS` Lambda function, the AWS Lambda function error header is matched.
        For all other `HTTP` and `AWS` backends, the HTTP status code is matched.
        """
        __props__['selectionPattern'] = selection_pattern

        if not status_code:
            raise TypeError('Missing required property status_code')
        elif not isinstance(status_code, basestring):
            raise TypeError('Expected property status_code to be a basestring')
        __self__.status_code = status_code
        """
        The HTTP status code
        """
        __props__['statusCode'] = status_code

        super(IntegrationResponse, __self__).__init__(
            'aws:apigateway/integrationResponse:IntegrationResponse',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'contentHandling' in outs:
            self.content_handling = outs['contentHandling']
        if 'httpMethod' in outs:
            self.http_method = outs['httpMethod']
        if 'resourceId' in outs:
            self.resource_id = outs['resourceId']
        if 'responseParameters' in outs:
            self.response_parameters = outs['responseParameters']
        if 'responseParametersInJson' in outs:
            self.response_parameters_in_json = outs['responseParametersInJson']
        if 'responseTemplates' in outs:
            self.response_templates = outs['responseTemplates']
        if 'restApi' in outs:
            self.rest_api = outs['restApi']
        if 'selectionPattern' in outs:
            self.selection_pattern = outs['selectionPattern']
        if 'statusCode' in outs:
            self.status_code = outs['statusCode']
