# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class GraphQLApi(pulumi.CustomResource):
    """
    Provides an AppSync GraphQL API.
    """
    def __init__(__self__, __name__, __opts__=None, authentication_type=None, name=None, user_pool_config=None):
        """Create a GraphQLApi resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not authentication_type:
            raise TypeError('Missing required property authentication_type')
        elif not isinstance(authentication_type, basestring):
            raise TypeError('Expected property authentication_type to be a basestring')
        __self__.authentication_type = authentication_type
        """
        The authentication type. Valid values: `API_KEY`, `AWS_IAM` and `AMAZON_COGNITO_USER_POOLS`
        """
        __props__['authenticationType'] = authentication_type

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        A user-supplied name for the GraphqlApi.
        """
        __props__['name'] = name

        if user_pool_config and not isinstance(user_pool_config, dict):
            raise TypeError('Expected property user_pool_config to be a dict')
        __self__.user_pool_config = user_pool_config
        """
        The Amazon Cognito User Pool configuration. See [below](#user_pool_config)
        """
        __props__['userPoolConfig'] = user_pool_config

        __self__.arn = pulumi.runtime.UNKNOWN
        """
        The ARN
        """

        super(GraphQLApi, __self__).__init__(
            'aws:appsync/graphQLApi:GraphQLApi',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'arn' in outs:
            self.arn = outs['arn']
        if 'authenticationType' in outs:
            self.authentication_type = outs['authenticationType']
        if 'name' in outs:
            self.name = outs['name']
        if 'userPoolConfig' in outs:
            self.user_pool_config = outs['userPoolConfig']
