# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class SecretVersion(pulumi.CustomResource):
    """
    Provides a resource to manage AWS Secrets Manager secret version including its secret value. To manage secret metadata, see the [`aws_secretsmanager_secret` resource](/docs/providers/aws/r/secretsmanager_secret.html).
    
    ~> **NOTE:** If the `AWSCURRENT` staging label is present on this version during resource deletion, that label cannot be removed and will be skipped to prevent errors when fully deleting the secret. That label will leave this secret version active even after the resource is deleted from Terraform unless the secret itself is deleted. Move the `AWSCURRENT` staging label before or after deleting this resource from Terraform to fully trigger version deprecation if necessary.
    """
    def __init__(__self__, __name__, __opts__=None, secret_id=None, secret_string=None, version_stages=None):
        """Create a SecretVersion resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not secret_id:
            raise TypeError('Missing required property secret_id')
        elif not isinstance(secret_id, basestring):
            raise TypeError('Expected property secret_id to be a basestring')
        __self__.secret_id = secret_id
        """
        Specifies the secret to which you want to add a new version. You can specify either the Amazon Resource Name (ARN) or the friendly name of the secret. The secret must already exist.
        """
        __props__['secretId'] = secret_id

        if not secret_string:
            raise TypeError('Missing required property secret_string')
        elif not isinstance(secret_string, basestring):
            raise TypeError('Expected property secret_string to be a basestring')
        __self__.secret_string = secret_string
        """
        Specifies text data that you want to encrypt and store in this version of the secret.
        """
        __props__['secretString'] = secret_string

        if version_stages and not isinstance(version_stages, list):
            raise TypeError('Expected property version_stages to be a list')
        __self__.version_stages = version_stages
        """
        Specifies a list of staging labels that are attached to this version of the secret. A staging label must be unique to a single version of the secret. If you specify a staging label that's already associated with a different version of the same secret then that staging label is automatically removed from the other version and attached to this version. If you do not specify a value, then AWS Secrets Manager automatically moves the staging label `AWSCURRENT` to this new version on creation.
        """
        __props__['versionStages'] = version_stages

        __self__.version_id = pulumi.runtime.UNKNOWN
        """
        The unique identifier of the version of the secret.
        """

        super(SecretVersion, __self__).__init__(
            'aws:secretsmanager/secretVersion:SecretVersion',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'secretId' in outs:
            self.secret_id = outs['secretId']
        if 'secretString' in outs:
            self.secret_string = outs['secretString']
        if 'versionId' in outs:
            self.version_id = outs['versionId']
        if 'versionStages' in outs:
            self.version_stages = outs['versionStages']
